/* ./irtviewer.c :  entry=irtviewer */
/* compiled by EusLisp 9.26() for Linux created on ip-172-30-1-97(Mon Dec 17 09:43:48 PST 2018) */
#include "eus.h"
#include "irtviewer.h"
#pragma init (register_irtviewer)
extern double fabs();
extern pointer fcallx();
static void init_ftab();
extern pointer loadglobal(),storeglobal();
static pointer module,*qv,codevec,quotevec;
extern pointer ___irtviewer();
extern pointer build_quote_vector();
static int register_irtviewer()
  { add_module_initializer("___irtviewer", ___irtviewer);}

static pointer F2757make_lr_ud_coords();
static pointer F2758draw_things();
static pointer F2759objects();
static pointer F2760make_irtviewer();
static pointer F2761make_irtviewer_dummy();

/*make-lr-ud-coords*/
static pointer F2757make_lr_ud_coords(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	ctx->vsp=local+0;
	w=(*ftab[0])(ctx,0,local+0,&ftab[0],fqv[0]); /*geometry:make-coords*/
	local[0]= w;
	local[1]= local[0];
	local[2]= fqv[1];
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(*ftab[1])(ctx,1,local+3,&ftab[1],fqv[2]); /*deg2rad*/
	local[3]= w;
	local[4]= fqv[3];
	ctx->vsp=local+5;
	w=(pointer)SEND(ctx,4,local+1); /*send*/
	local[1]= local[0];
	local[2]= fqv[1];
	local[3]= argv[1];
	ctx->vsp=local+4;
	w=(*ftab[1])(ctx,1,local+3,&ftab[1],fqv[2]); /*deg2rad*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(pointer)MINUS(ctx,1,local+3); /*-*/
	local[3]= w;
	local[4]= fqv[4];
	ctx->vsp=local+5;
	w=(pointer)SEND(ctx,4,local+1); /*send*/
	w = local[0];
	local[0]= w;
BLK2762:
	ctx->vsp=local; return(local[0]);}

/*:draw-circle*/
static pointer M2763geometry_viewer_draw_circle(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<3) maerror();
	ctx->vsp=local+0;
	n=parsekeyparams(fqv[5], &argv[3], n-3, local+0, 0);
	if (n & (1<<0)) goto KEY2765;
	local[0] = makeint(50);
KEY2765:
	if (n & (1<<1)) goto KEY2766;
	local[1] = NIL;
KEY2766:
	if (n & (1<<2)) goto KEY2767;
	local[2] = NIL;
KEY2767:
	if (n & (1<<3)) goto KEY2768;
	local[3] = makeflt(6.28318405e+00);
KEY2768:
	if (n & (1<<4)) goto KEY2769;
	local[4] = fqv[6];
KEY2769:
	local[5]= makeint(16);
	local[6]= local[3];
	local[7]= local[5];
	ctx->vsp=local+8;
	w=(pointer)QUOTIENT(ctx,2,local+6); /*/*/
	local[6]= w;
	local[7]= NIL;
	local[8]= NIL;
	local[9]= makeint(0);
	local[10]= local[5];
WHL2771:
	local[11]= local[9];
	w = local[10];
	if ((eusinteger_t)local[11] >= (eusinteger_t)w) goto WHX2772;
	local[11]= argv[2];
	local[12]= fqv[7];
	local[13]= local[0];
	local[14]= local[9];
	local[15]= local[6];
	ctx->vsp=local+16;
	w=(pointer)TIMES(ctx,2,local+14); /***/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)SIN(ctx,1,local+14); /*sin*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)TIMES(ctx,2,local+13); /***/
	local[13]= w;
	local[14]= local[0];
	local[15]= local[9];
	local[16]= local[6];
	ctx->vsp=local+17;
	w=(pointer)TIMES(ctx,2,local+15); /***/
	local[15]= w;
	ctx->vsp=local+16;
	w=(pointer)COS(ctx,1,local+15); /*cos*/
	local[15]= w;
	ctx->vsp=local+16;
	w=(pointer)TIMES(ctx,2,local+14); /***/
	local[14]= w;
	local[15]= makeint(0);
	ctx->vsp=local+16;
	w=(pointer)MKFLTVEC(ctx,3,local+13); /*float-vector*/
	local[13]= w;
	ctx->vsp=local+14;
	w=(pointer)SEND(ctx,3,local+11); /*send*/
	local[8] = w;
	if (local[7]==NIL) goto IF2774;
	local[11]= argv[0];
	local[12]= fqv[8];
	local[13]= local[7];
	local[14]= local[8];
	ctx->vsp=local+15;
	w=(pointer)SEND(ctx,4,local+11); /*send*/
	local[11]= w;
	goto IF2775;
IF2774:
	local[11]= NIL;
IF2775:
	local[7] = local[8];
	local[11]= local[9];
	ctx->vsp=local+12;
	w=(pointer)ADD1(ctx,1,local+11); /*1+*/
	local[9] = w;
	goto WHL2771;
WHX2772:
	local[11]= NIL;
BLK2773:
	w = NIL;
	local[9]= argv[2];
	local[10]= fqv[7];
	local[11]= local[0];
	local[12]= local[5];
	local[13]= local[6];
	ctx->vsp=local+14;
	w=(pointer)TIMES(ctx,2,local+12); /***/
	local[12]= w;
	ctx->vsp=local+13;
	w=(pointer)SIN(ctx,1,local+12); /*sin*/
	local[12]= w;
	ctx->vsp=local+13;
	w=(pointer)TIMES(ctx,2,local+11); /***/
	local[11]= w;
	local[12]= local[0];
	local[13]= local[5];
	local[14]= local[6];
	ctx->vsp=local+15;
	w=(pointer)TIMES(ctx,2,local+13); /***/
	local[13]= w;
	ctx->vsp=local+14;
	w=(pointer)COS(ctx,1,local+13); /*cos*/
	local[13]= w;
	ctx->vsp=local+14;
	w=(pointer)TIMES(ctx,2,local+12); /***/
	local[12]= w;
	local[13]= makeint(0);
	ctx->vsp=local+14;
	w=(pointer)MKFLTVEC(ctx,3,local+11); /*float-vector*/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)SEND(ctx,3,local+9); /*send*/
	local[8] = w;
	if (local[2]==NIL) goto IF2776;
	local[9]= argv[0];
	local[10]= fqv[9];
	local[11]= local[7];
	local[12]= local[8];
	local[13]= T;
	local[14]= NIL;
	local[15]= fqv[10];
	local[16]= local[4];
	ctx->vsp=local+17;
	w=(pointer)SEND(ctx,8,local+9); /*send*/
	local[9]= w;
	goto IF2777;
IF2776:
	local[9]= argv[0];
	local[10]= fqv[8];
	local[11]= local[7];
	local[12]= local[8];
	ctx->vsp=local+13;
	w=(pointer)SEND(ctx,4,local+9); /*send*/
	local[9]= w;
IF2777:
	if (local[1]==NIL) goto IF2778;
	local[9]= argv[0];
	local[10]= fqv[11];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	local[9]= w;
	goto IF2779;
IF2778:
	local[9]= NIL;
IF2779:
	w = local[9];
	local[0]= w;
BLK2764:
	ctx->vsp=local; return(local[0]);}

/*:draw-objects*/
static pointer M2780geometry_viewer_draw_objects(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2782:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	local[1]= (pointer)get_sym_func(fqv[12]);
	local[2]= argv[0];
	local[3]= fqv[13];
	ctx->vsp=local+4;
	w=(pointer)GETPROP(ctx,2,local+2); /*get*/
	local[2]= w;
	local[3]= fqv[14];
	local[4]= local[0];
	ctx->vsp=local+5;
	w=(pointer)APPLY(ctx,4,local+1); /*apply*/
	local[0]= w;
BLK2781:
	ctx->vsp=local; return(local[0]);}

/*:create*/
static pointer M2783irtviewer_create(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2785:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	ctx->vsp=local+1;
	n=parsekeyparams(fqv[15], &argv[2], n-2, local+1, 1);
	if (n & (1<<0)) goto KEY2786;
	local[1] = fqv[16];
KEY2786:
	if (n & (1<<1)) goto KEY2787;
	local[9]= fqv[17];
	ctx->vsp=local+10;
	w=(pointer)GENSYM(ctx,1,local+9); /*gensym*/
	local[2] = w;
KEY2787:
	if (n & (1<<2)) goto KEY2788;
	local[3] = makeflt(2.00000000e+02);
KEY2788:
	if (n & (1<<3)) goto KEY2789;
	local[4] = makeflt(5.00000000e+04);
KEY2789:
	if (n & (1<<4)) goto KEY2790;
	local[5] = makeint(500);
KEY2790:
	if (n & (1<<5)) goto KEY2791;
	local[6] = makeint(500);
KEY2791:
	if (n & (1<<6)) goto KEY2792;
	local[7] = makeint(150);
KEY2792:
	if (n & (1<<7)) goto KEY2793;
	local[8] = NIL;
KEY2793:
	argv[0]->c.obj.iv[29] = makeint(60);
	argv[0]->c.obj.iv[30] = makeint(20);
	local[9]= makeint(700);
	local[10]= makeint(400);
	local[11]= makeint(250);
	ctx->vsp=local+12;
	w=(pointer)MKFLTVEC(ctx,3,local+9); /*float-vector*/
	argv[0]->c.obj.iv[31] = w;
	local[9]= makeint(0);
	local[10]= makeint(0);
	local[11]= makeint(0);
	ctx->vsp=local+12;
	w=(pointer)MKFLTVEC(ctx,3,local+9); /*float-vector*/
	argv[0]->c.obj.iv[32] = w;
	argv[0]->c.obj.iv[34] = local[7];
	argv[0]->c.obj.iv[35] = local[8];
	local[9]= (pointer)get_sym_func(fqv[18]);
	local[10]= argv[0];
	local[11]= *(ovafptr(argv[1],fqv[19]));
	local[12]= fqv[20];
	local[13]= fqv[21];
	local[14]= local[5];
	local[15]= fqv[22];
	local[16]= local[6];
	local[17]= fqv[23];
	local[18]= local[1];
	local[19]= fqv[24];
	local[20]= fqv[25];
	local[21]= local[0];
	ctx->vsp=local+22;
	w=(pointer)APPLY(ctx,13,local+9); /*apply*/
	local[9]= local[4];
	storeglobal(fqv[26],local[9]);
	local[9]= local[3];
	storeglobal(fqv[27],local[9]);
	local[9]= (pointer)get_sym_func(fqv[28]);
	local[10]= fqv[29];
	local[11]= argv[0];
	local[12]= fqv[30];
	local[13]= makeint(0);
	local[14]= fqv[4];
	local[15]= makeint(0);
	local[16]= fqv[21];
	local[17]= local[5];
	local[18]= fqv[22];
	local[19]= local[6];
	local[20]= fqv[23];
	local[21]= local[1];
	local[22]= fqv[31];
	local[23]= local[2];
	local[24]= local[0];
	ctx->vsp=local+25;
	w=(pointer)APPLY(ctx,16,local+9); /*apply*/
	argv[0]->c.obj.iv[25] = w;
	local[9]= argv[0]->c.obj.iv[25];
	local[10]= argv[0];
	local[11]= fqv[13];
	ctx->vsp=local+12;
	w=(pointer)PUTPROP(ctx,3,local+9); /*putprop*/
	local[9]= argv[0]->c.obj.iv[25];
	storeglobal(fqv[32],local[9]);
	local[9]= makeflt(9.99999940e-02);
	local[10]= makeflt(9.99999940e-02);
	local[11]= makeflt(9.99999940e-02);
	local[12]= makeflt(1.00000000e+00);
	ctx->vsp=local+13;
	w=(pointer)MKFLTVEC(ctx,4,local+9); /*float-vector*/
	local[9]= w;
	local[10]= makeflt(1.00000000e+00);
	local[11]= makeflt(1.00000000e+00);
	local[12]= makeflt(1.00000000e+00);
	local[13]= makeflt(1.00000000e+00);
	ctx->vsp=local+14;
	w=(pointer)MKFLTVEC(ctx,4,local+10); /*float-vector*/
	local[10]= w;
	local[11]= makeflt(9.99999940e-02);
	local[12]= makeflt(9.99999940e-02);
	local[13]= makeflt(9.99999940e-02);
	local[14]= makeflt(1.00000000e+00);
	ctx->vsp=local+15;
	w=(pointer)MKFLTVEC(ctx,4,local+11); /*float-vector*/
	local[11]= w;
	local[12]= makeflt(1.00000000e+00);
	local[13]= makeflt(6.99999809e-01);
	local[14]= makeflt(3.99999976e-01);
	local[15]= makeflt(2.50000000e-01);
	local[16]= loadglobal(fqv[33]);
	ctx->vsp=local+17;
	w=(pointer)INSTANTIATE(ctx,1,local+16); /*instantiate*/
	local[16]= w;
	local[17]= local[16];
	local[18]= fqv[20];
	local[19]= makeint(0);
	local[20]= fqv[34];
	local[21]= local[12];
	local[22]= local[9];
	ctx->vsp=local+23;
	w=(pointer)SCALEVEC(ctx,2,local+21); /*scale*/
	local[21]= w;
	local[22]= fqv[35];
	local[23]= local[12];
	local[24]= local[10];
	ctx->vsp=local+25;
	w=(pointer)SCALEVEC(ctx,2,local+23); /*scale*/
	local[23]= w;
	local[24]= fqv[36];
	local[25]= local[12];
	local[26]= local[11];
	ctx->vsp=local+27;
	w=(pointer)SCALEVEC(ctx,2,local+25); /*scale*/
	local[25]= w;
	local[26]= fqv[37];
	local[27]= makeflt(4.00000000e+03);
	local[28]= makeflt(3.00000000e+03);
	local[29]= makeflt(0.00000000e+00);
	local[30]= makeflt(0.00000000e+00);
	ctx->vsp=local+31;
	w=(pointer)MKFLTVEC(ctx,4,local+27); /*float-vector*/
	local[27]= w;
	ctx->vsp=local+28;
	w=(pointer)SEND(ctx,11,local+17); /*send*/
	w = local[16];
	local[16]= w;
	storeglobal(fqv[38],w);
	local[16]= loadglobal(fqv[33]);
	ctx->vsp=local+17;
	w=(pointer)INSTANTIATE(ctx,1,local+16); /*instantiate*/
	local[16]= w;
	local[17]= local[16];
	local[18]= fqv[20];
	local[19]= makeint(1);
	local[20]= fqv[34];
	local[21]= local[13];
	local[22]= local[9];
	ctx->vsp=local+23;
	w=(pointer)SCALEVEC(ctx,2,local+21); /*scale*/
	local[21]= w;
	local[22]= fqv[35];
	local[23]= local[13];
	local[24]= local[10];
	ctx->vsp=local+25;
	w=(pointer)SCALEVEC(ctx,2,local+23); /*scale*/
	local[23]= w;
	local[24]= fqv[36];
	local[25]= local[13];
	local[26]= local[11];
	ctx->vsp=local+27;
	w=(pointer)SCALEVEC(ctx,2,local+25); /*scale*/
	local[25]= w;
	local[26]= fqv[37];
	local[27]= makeflt(-4.00000000e+03);
	local[28]= makeflt(-2.00000000e+03);
	local[29]= makeflt(-2.00000000e+03);
	local[30]= makeflt(0.00000000e+00);
	ctx->vsp=local+31;
	w=(pointer)MKFLTVEC(ctx,4,local+27); /*float-vector*/
	local[27]= w;
	ctx->vsp=local+28;
	w=(pointer)SEND(ctx,11,local+17); /*send*/
	w = local[16];
	local[16]= w;
	storeglobal(fqv[39],w);
	local[16]= loadglobal(fqv[33]);
	ctx->vsp=local+17;
	w=(pointer)INSTANTIATE(ctx,1,local+16); /*instantiate*/
	local[16]= w;
	local[17]= local[16];
	local[18]= fqv[20];
	local[19]= makeint(2);
	local[20]= fqv[34];
	local[21]= local[14];
	local[22]= local[9];
	ctx->vsp=local+23;
	w=(pointer)SCALEVEC(ctx,2,local+21); /*scale*/
	local[21]= w;
	local[22]= fqv[35];
	local[23]= local[14];
	local[24]= local[10];
	ctx->vsp=local+25;
	w=(pointer)SCALEVEC(ctx,2,local+23); /*scale*/
	local[23]= w;
	local[24]= fqv[36];
	local[25]= local[14];
	local[26]= local[11];
	ctx->vsp=local+27;
	w=(pointer)SCALEVEC(ctx,2,local+25); /*scale*/
	local[25]= w;
	local[26]= fqv[37];
	local[27]= makeflt(-2.00000000e+03);
	local[28]= makeflt(-2.00000000e+03);
	local[29]= makeflt(2.50000000e+03);
	local[30]= makeflt(0.00000000e+00);
	ctx->vsp=local+31;
	w=(pointer)MKFLTVEC(ctx,4,local+27); /*float-vector*/
	local[27]= w;
	ctx->vsp=local+28;
	w=(pointer)SEND(ctx,11,local+17); /*send*/
	w = local[16];
	local[16]= w;
	storeglobal(fqv[40],w);
	local[16]= loadglobal(fqv[33]);
	ctx->vsp=local+17;
	w=(pointer)INSTANTIATE(ctx,1,local+16); /*instantiate*/
	local[16]= w;
	local[17]= local[16];
	local[18]= fqv[20];
	local[19]= makeint(3);
	local[20]= fqv[34];
	local[21]= local[15];
	local[22]= local[9];
	ctx->vsp=local+23;
	w=(pointer)SCALEVEC(ctx,2,local+21); /*scale*/
	local[21]= w;
	local[22]= fqv[35];
	local[23]= local[15];
	local[24]= local[10];
	ctx->vsp=local+25;
	w=(pointer)SCALEVEC(ctx,2,local+23); /*scale*/
	local[23]= w;
	local[24]= fqv[36];
	local[25]= local[15];
	local[26]= local[11];
	ctx->vsp=local+27;
	w=(pointer)SCALEVEC(ctx,2,local+25); /*scale*/
	local[25]= w;
	local[26]= fqv[37];
	local[27]= makeflt(0.00000000e+00);
	local[28]= makeflt(0.00000000e+00);
	local[29]= makeflt(0.00000000e+00);
	local[30]= makeflt(1.00000000e+00);
	ctx->vsp=local+31;
	w=(pointer)MKFLTVEC(ctx,4,local+27); /*float-vector*/
	local[27]= w;
	ctx->vsp=local+28;
	w=(pointer)SEND(ctx,11,local+17); /*send*/
	w = local[16];
	local[16]= w;
	storeglobal(fqv[41],w);
	w = local[16];
	local[9]= loadglobal(fqv[38]);
	local[10]= fqv[42];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	local[9]= loadglobal(fqv[39]);
	local[10]= fqv[42];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	local[9]= loadglobal(fqv[40]);
	local[10]= fqv[42];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	local[9]= loadglobal(fqv[41]);
	local[10]= fqv[42];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	local[9]= argv[0]->c.obj.iv[25];
	local[10]= fqv[43];
	local[11]= fqv[44];
	local[12]= fqv[45];
	local[13]= fqv[46];
	local[14]= argv[0];
	ctx->vsp=local+15;
	w=(pointer)SEND(ctx,6,local+9); /*send*/
	local[9]= argv[0]->c.obj.iv[25];
	local[10]= fqv[43];
	local[11]= fqv[44];
	local[12]= fqv[47];
	local[13]= fqv[48];
	local[14]= argv[0];
	ctx->vsp=local+15;
	w=(pointer)SEND(ctx,6,local+9); /*send*/
	local[9]= argv[0]->c.obj.iv[25];
	local[10]= fqv[43];
	local[11]= fqv[44];
	local[12]= fqv[49];
	local[13]= fqv[50];
	local[14]= argv[0];
	ctx->vsp=local+15;
	w=(pointer)SEND(ctx,6,local+9); /*send*/
	local[9]= argv[0]->c.obj.iv[25];
	local[10]= fqv[43];
	local[11]= fqv[44];
	local[12]= fqv[51];
	local[13]= fqv[50];
	local[14]= argv[0];
	ctx->vsp=local+15;
	w=(pointer)SEND(ctx,6,local+9); /*send*/
	local[9]= argv[0];
	local[10]= fqv[52];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	local[9]= argv[0];
	local[10]= fqv[14];
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,2,local+9); /*send*/
	w = argv[0];
	local[0]= w;
BLK2784:
	ctx->vsp=local; return(local[0]);}

/*:viewer*/
static pointer M2798irtviewer_viewer(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2800:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	local[1]= argv[0]->c.obj.iv[25];
	local[2]= local[0];
	ctx->vsp=local+3;
	w=(*ftab[2])(ctx,2,local+1,&ftab[2],fqv[53]); /*user::forward-message-to*/
	local[0]= w;
BLK2799:
	ctx->vsp=local; return(local[0]);}

/*:redraw*/
static pointer M2801irtviewer_redraw(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	local[0]= argv[0];
	local[1]= fqv[14];
	ctx->vsp=local+2;
	w=(pointer)SEND(ctx,2,local+0); /*send*/
	local[0]= w;
BLK2802:
	ctx->vsp=local; return(local[0]);}

/*:expose*/
static pointer M2803irtviewer_expose(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	w = argv[2];
	ctx->vsp=local+0;
	bindspecial(ctx,fqv[54],w);
	local[3]= NIL;
	ctx->vsp=local+4;
	unbindx(ctx,1);
	w = local[3];
	local[0]= w;
BLK2804:
	ctx->vsp=local; return(local[0]);}

/*:resize*/
static pointer M2805irtviewer_resize(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=4) maerror();
	argv[0]->c.obj.iv[5] = argv[2];
	argv[0]->c.obj.iv[6] = argv[3];
	local[0]= argv[0];
	local[1]= *(ovafptr(argv[1],fqv[19]));
	local[2]= fqv[55];
	local[3]= argv[2];
	local[4]= argv[3];
	ctx->vsp=local+5;
	w=(pointer)SENDMESSAGE(ctx,5,local+0); /*send-message*/
	local[0]= argv[0]->c.obj.iv[25];
	local[1]= fqv[43];
	local[2]= fqv[55];
	local[3]= argv[2];
	local[4]= argv[3];
	ctx->vsp=local+5;
	w=(pointer)SEND(ctx,5,local+0); /*send*/
	local[0]= argv[0]->c.obj.iv[25];
	local[1]= fqv[43];
	local[2]= fqv[56];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	local[0]= argv[0]->c.obj.iv[25];
	local[1]= fqv[43];
	local[2]= fqv[57];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	local[0]= argv[2];
	local[1]= argv[3];
	ctx->vsp=local+2;
	w=(pointer)MAX(ctx,2,local+0); /*max*/
	local[0]= w;
	local[1]= argv[0]->c.obj.iv[25];
	local[2]= fqv[58];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,2,local+1); /*send*/
	local[1]= w;
	local[2]= fqv[55];
	local[3]= fqv[21];
	local[4]= local[0];
	local[5]= fqv[22];
	local[6]= local[0];
	ctx->vsp=local+7;
	w=(pointer)MINUS(ctx,1,local+6); /*-*/
	local[6]= w;
	local[7]= fqv[59];
	local[8]= argv[2];
	local[9]= makeint(2);
	ctx->vsp=local+10;
	w=(pointer)QUOTIENT(ctx,2,local+8); /*/*/
	local[8]= w;
	local[9]= fqv[60];
	local[10]= argv[3];
	local[11]= makeint(2);
	ctx->vsp=local+12;
	w=(pointer)QUOTIENT(ctx,2,local+10); /*/*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)SEND(ctx,10,local+1); /*send*/
	local[0]= argv[0];
	local[1]= fqv[61];
	ctx->vsp=local+2;
	w=(pointer)SEND(ctx,2,local+0); /*send*/
	local[0]= w;
BLK2806:
	ctx->vsp=local; return(local[0]);}

/*:configurenotify*/
static pointer M2807irtviewer_configurenotify(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	w = argv[2];
	ctx->vsp=local+0;
	bindspecial(ctx,fqv[54],w);
	if (loadglobal(fqv[62])==NIL) goto IF2809;
	local[3]= fqv[63];
	local[4]= argv[0];
	ctx->vsp=local+5;
	w=(*ftab[3])(ctx,2,local+3,&ftab[3],fqv[64]); /*warn*/
	local[3]= w;
	goto IF2810;
IF2809:
	local[3]= NIL;
IF2810:
	local[3]= argv[0];
	local[4]= loadglobal(fqv[65]);
	local[5]= fqv[21];
	ctx->vsp=local+6;
	w=(pointer)SENDMESSAGE(ctx,3,local+3); /*send-message*/
	local[3]= w;
	local[4]= argv[0];
	local[5]= loadglobal(fqv[65]);
	local[6]= fqv[22];
	ctx->vsp=local+7;
	w=(pointer)SENDMESSAGE(ctx,3,local+4); /*send-message*/
	local[4]= w;
	local[5]= local[3];
	local[6]= argv[0]->c.obj.iv[5];
	ctx->vsp=local+7;
	w=(*ftab[4])(ctx,2,local+5,&ftab[4],fqv[66]); /*/=*/
	if (w!=NIL) goto OR2813;
	local[5]= local[4];
	local[6]= argv[0]->c.obj.iv[6];
	ctx->vsp=local+7;
	w=(*ftab[4])(ctx,2,local+5,&ftab[4],fqv[66]); /*/=*/
	if (w!=NIL) goto OR2813;
	goto IF2811;
OR2813:
	local[5]= argv[0];
	local[6]= fqv[55];
	local[7]= local[3];
	local[8]= local[4];
	ctx->vsp=local+9;
	w=(pointer)SEND(ctx,4,local+5); /*send*/
	local[5]= w;
	goto IF2812;
IF2811:
	local[5]= NIL;
IF2812:
	w = local[5];
	local[3]= w;
	ctx->vsp=local+4;
	unbindx(ctx,1);
	w = local[3];
	local[0]= w;
BLK2808:
	ctx->vsp=local; return(local[0]);}

/*:viewtarget*/
static pointer M2814irtviewer_viewtarget(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
	if (n>=3) { local[0]=(argv[2]); goto ENT2817;}
	local[0]= NIL;
ENT2817:
ENT2816:
	if (n>3) maerror();
	if (local[0]==NIL) goto IF2818;
	argv[0]->c.obj.iv[32] = local[0];
	local[1]= argv[0]->c.obj.iv[32];
	goto IF2819;
IF2818:
	local[1]= NIL;
IF2819:
	w = argv[0]->c.obj.iv[32];
	local[0]= w;
BLK2815:
	ctx->vsp=local; return(local[0]);}

/*:viewpoint*/
static pointer M2820irtviewer_viewpoint(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
	if (n>=3) { local[0]=(argv[2]); goto ENT2823;}
	local[0]= NIL;
ENT2823:
ENT2822:
	if (n>3) maerror();
	if (local[0]==NIL) goto IF2824;
	argv[0]->c.obj.iv[31] = local[0];
	local[1]= argv[0]->c.obj.iv[31];
	goto IF2825;
IF2824:
	local[1]= NIL;
IF2825:
	w = argv[0]->c.obj.iv[31];
	local[0]= w;
BLK2821:
	ctx->vsp=local; return(local[0]);}

/*:look1*/
static pointer M2826irtviewer_look1(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
	if (n>=3) { local[0]=(argv[2]); goto ENT2831;}
	local[0]= argv[0]->c.obj.iv[32];
ENT2831:
	if (n>=4) { local[1]=(argv[3]); goto ENT2830;}
	local[1]= argv[0]->c.obj.iv[29];
ENT2830:
	if (n>=5) { local[2]=(argv[4]); goto ENT2829;}
	local[2]= argv[0]->c.obj.iv[30];
ENT2829:
ENT2828:
	if (n>5) maerror();
	local[3]= local[1];
	local[4]= local[2];
	ctx->vsp=local+5;
	w=(pointer)F2757make_lr_ud_coords(ctx,2,local+3); /*make-lr-ud-coords*/
	local[3]= w;
	local[4]= local[0];
	local[5]= local[3];
	local[6]= fqv[7];
	local[7]= argv[0]->c.obj.iv[31];
	local[8]= local[0];
	ctx->vsp=local+9;
	w=(pointer)VMINUS(ctx,2,local+7); /*v-*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)VNORM(ctx,1,local+7); /*norm*/
	local[7]= w;
	local[8]= makeint(0);
	local[9]= makeint(0);
	ctx->vsp=local+10;
	w=(pointer)MKFLTVEC(ctx,3,local+7); /*float-vector*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SEND(ctx,3,local+5); /*send*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)VPLUS(ctx,2,local+4); /*v+*/
	local[4]= w;
	local[5]= local[3];
	local[6]= fqv[67];
	local[7]= makeint(0);
	local[8]= makeint(0);
	local[9]= makeint(1);
	ctx->vsp=local+10;
	w=(pointer)MKFLTVEC(ctx,3,local+7); /*float-vector*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SEND(ctx,3,local+5); /*send*/
	local[5]= w;
	local[6]= argv[0];
	local[7]= fqv[68];
	local[8]= local[4];
	ctx->vsp=local+9;
	w=(pointer)SEND(ctx,3,local+6); /*send*/
	local[6]= argv[0];
	local[7]= fqv[69];
	local[8]= fqv[70];
	ctx->vsp=local+9;
	w=(pointer)SEND(ctx,3,local+6); /*send*/
	if (w==NIL) goto IF2832;
	local[6]= argv[0];
	local[7]= fqv[69];
	local[8]= fqv[70];
	local[9]= fqv[71];
	local[10]= argv[0]->c.obj.iv[31];
	local[11]= local[0];
	local[12]= local[5];
	ctx->vsp=local+13;
	w=(pointer)SEND(ctx,7,local+6); /*send*/
	local[6]= w;
	goto IF2833;
IF2832:
	local[6]= NIL;
IF2833:
	w = local[6];
	local[0]= w;
BLK2827:
	ctx->vsp=local; return(local[0]);}

/*:look-all*/
static pointer M2834irtviewer_look_all(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
	if (n>=3) { local[0]=(argv[2]); goto ENT2837;}
	local[0]= NIL;
ENT2837:
ENT2836:
	if (n>3) maerror();
	local[1]= local[0];
	local[2]= loadglobal(fqv[72]);
	ctx->vsp=local+3;
	w=(pointer)DERIVEDP(ctx,2,local+1); /*derivedp*/
	local[1]= w;
	if (w!=NIL) goto CON2838;
CON2839:
	if (local[0]!=NIL) goto CON2840;
	local[1]= argv[0]->c.obj.iv[27];
	local[2]= fqv[73];
	ctx->vsp=local+3;
	w=(*ftab[5])(ctx,2,local+1,&ftab[5],fqv[74]); /*send-all*/
	local[1]= argv[0]->c.obj.iv[27];
	local[2]= fqv[75];
	ctx->vsp=local+3;
	w=(*ftab[5])(ctx,2,local+1,&ftab[5],fqv[74]); /*send-all*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(*ftab[6])(ctx,1,local+1,&ftab[6],fqv[76]); /*flatten*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(*ftab[7])(ctx,1,local+1,&ftab[7],fqv[77]); /*geometry:make-bounding-box*/
	local[0] = w;
	local[1]= local[0];
	goto CON2838;
CON2840:
	if (local[0]==NIL) goto CON2841;
	local[1]= local[0];
	ctx->vsp=local+2;
	w=(pointer)F2758draw_things(ctx,1,local+1); /*draw-things*/
	local[1]= w;
	local[2]= fqv[75];
	ctx->vsp=local+3;
	w=(*ftab[5])(ctx,2,local+1,&ftab[5],fqv[74]); /*send-all*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(*ftab[6])(ctx,1,local+1,&ftab[6],fqv[76]); /*flatten*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(*ftab[7])(ctx,1,local+1,&ftab[7],fqv[77]); /*geometry:make-bounding-box*/
	local[0] = w;
	local[1]= local[0];
	goto CON2838;
CON2841:
	local[1]= NIL;
CON2838:
	if (local[0]==NIL) goto IF2842;
	local[1]= NIL;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= local[0];
	local[5]= fqv[78];
	ctx->vsp=local+6;
	w=(pointer)SEND(ctx,2,local+4); /*send*/
	local[1] = w;
	local[4]= (pointer)get_sym_func(fqv[79]);
	local[5]= local[0];
	local[6]= fqv[80];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,2,local+5); /*send*/
	local[5]= w;
	local[6]= loadglobal(fqv[81]);
	ctx->vsp=local+7;
	w=(pointer)COERCE(ctx,2,local+5); /*coerce*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)APPLY(ctx,2,local+4); /*apply*/
	local[4]= w;
	local[5]= makeflt(5.00000000e-01);
	local[6]= argv[0];
	local[7]= fqv[69];
	local[8]= fqv[70];
	local[9]= fqv[82];
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,4,local+6); /*send*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)TAN(ctx,1,local+6); /*tan*/
	{ double x,y;
		y=fltval(w); x=fltval(local[5]);
		local[5]=(makeflt(x * y));}
	ctx->vsp=local+6;
	w=(pointer)QUOTIENT(ctx,2,local+4); /*/*/
	local[3] = w;
	local[4]= local[3];
	local[5]= loadglobal(fqv[26]);
	ctx->vsp=local+6;
	w=(pointer)QUOTIENT(ctx,2,local+4); /*/*/
	local[4]= w;
	local[5]= makeint(2);
	ctx->vsp=local+6;
	w=(pointer)GREATERP(ctx,2,local+4); /*>*/
	if (w!=NIL) goto OR2846;
	local[4]= local[3];
	local[5]= loadglobal(fqv[26]);
	ctx->vsp=local+6;
	w=(pointer)QUOTIENT(ctx,2,local+4); /*/*/
	local[4]= w;
	local[5]= makeflt(9.99999698e-04);
	ctx->vsp=local+6;
	w=(pointer)LESSP(ctx,2,local+4); /*<*/
	if (w!=NIL) goto OR2846;
	goto IF2844;
OR2846:
	local[4]= makeint(2);
	local[5]= fqv[83];
	local[6]= local[3];
	local[7]= loadglobal(fqv[26]);
	ctx->vsp=local+8;
	w=(pointer)QUOTIENT(ctx,2,local+6); /*/*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(*ftab[8])(ctx,3,local+4,&ftab[8],fqv[84]); /*warning-message*/
	local[4]= local[3];
	local[5]= loadglobal(fqv[26]);
	ctx->vsp=local+6;
	w=(pointer)QUOTIENT(ctx,2,local+4); /*/*/
	local[4]= w;
	local[5]= loadglobal(fqv[27]);
	ctx->vsp=local+6;
	w=(pointer)TIMES(ctx,2,local+4); /***/
	storeglobal(fqv[27],w);
	local[4]= local[3];
	local[5]= loadglobal(fqv[26]);
	ctx->vsp=local+6;
	w=(pointer)QUOTIENT(ctx,2,local+4); /*/*/
	local[4]= w;
	local[5]= loadglobal(fqv[26]);
	ctx->vsp=local+6;
	w=(pointer)TIMES(ctx,2,local+4); /***/
	local[4]= w;
	storeglobal(fqv[26],w);
	goto IF2845;
IF2844:
	local[4]= NIL;
IF2845:
	local[4]= loadglobal(fqv[26]);
	local[5]= makeflt(7.99999952e-01);
	ctx->vsp=local+6;
	w=(pointer)TIMES(ctx,2,local+4); /***/
	local[4]= w;
	local[5]= loadglobal(fqv[27]);
	local[6]= makeflt(1.50000000e+00);
	ctx->vsp=local+7;
	w=(pointer)TIMES(ctx,2,local+5); /***/
	local[5]= w;
	local[6]= local[3];
	ctx->vsp=local+7;
	w=(pointer)MAX(ctx,2,local+5); /*max*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)MIN(ctx,2,local+4); /*min*/
	local[4]= w;
	local[5]= argv[0]->c.obj.iv[31];
	local[6]= argv[0]->c.obj.iv[32];
	ctx->vsp=local+7;
	w=(pointer)VMINUS(ctx,2,local+5); /*v-*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)VNORMALIZE(ctx,1,local+5); /*normalize-vector*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)SCALEVEC(ctx,2,local+4); /*scale*/
	local[2] = w;
	local[4]= argv[0];
	local[5]= fqv[85];
	local[6]= local[1];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,3,local+4); /*send*/
	local[4]= argv[0];
	local[5]= fqv[68];
	local[6]= local[1];
	local[7]= local[2];
	ctx->vsp=local+8;
	w=(pointer)VPLUS(ctx,2,local+6); /*v+*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,3,local+4); /*send*/
	local[1]= w;
	goto IF2843;
IF2842:
	local[1]= NIL;
IF2843:
	local[1]= argv[0];
	local[2]= fqv[52];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,2,local+1); /*send*/
	local[1]= argv[0];
	local[2]= fqv[14];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,2,local+1); /*send*/
	local[0]= w;
BLK2835:
	ctx->vsp=local; return(local[0]);}

/*:move-viewing-around-viewtarget*/
static pointer M2847irtviewer_move_viewing_around_viewtarget(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=8) maerror();
	w = argv[2];
	ctx->vsp=local+0;
	bindspecial(ctx,fqv[54],w);
	local[3]= loadglobal(fqv[54]);
	ctx->vsp=local+4;
	w=(*ftab[9])(ctx,1,local+3,&ftab[9],fqv[86]); /*event-middle*/
	if (w==NIL) goto CON2850;
	local[3]= argv[0]->c.obj.iv[31];
	local[4]= argv[0]->c.obj.iv[32];
	ctx->vsp=local+5;
	w=(pointer)VMINUS(ctx,2,local+3); /*v-*/
	local[3]= w;
	local[4]= argv[7];
	local[5]= fqv[70];
	local[6]= fqv[7];
	local[7]= makeflt(9.99999698e-04);
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(pointer)VNORM(ctx,1,local+8); /*norm*/
	{ double x,y;
		y=fltval(w); x=fltval(local[7]);
		local[7]=(makeflt(x * y));}
	local[8]= makeint(-1);
	local[9]= argv[5];
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	local[9]= argv[6];
	local[10]= makeint(0);
	ctx->vsp=local+11;
	w=(pointer)MKFLTVEC(ctx,3,local+8); /*float-vector*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)SCALEVEC(ctx,2,local+7); /*scale*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SEND(ctx,4,local+4); /*send*/
	local[4]= w;
	local[5]= argv[0];
	local[6]= fqv[85];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,2,local+5); /*send*/
	local[5]= w;
	local[6]= local[4];
	local[7]= argv[0]->c.obj.iv[31];
	ctx->vsp=local+8;
	w=(pointer)VMINUS(ctx,2,local+6); /*v-*/
	local[6]= w;
	local[7]= argv[0];
	local[8]= fqv[68];
	local[9]= local[4];
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,3,local+7); /*send*/
	local[7]= argv[0];
	local[8]= fqv[85];
	local[9]= local[5];
	local[10]= local[6];
	ctx->vsp=local+11;
	w=(pointer)VPLUS(ctx,2,local+9); /*v+*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,3,local+7); /*send*/
	local[3]= w;
	goto CON2849;
CON2850:
	local[3]= loadglobal(fqv[54]);
	ctx->vsp=local+4;
	w=(*ftab[10])(ctx,1,local+3,&ftab[10],fqv[87]); /*event-right*/
	if (w!=NIL) goto OR2852;
	local[3]= makeint(60);
	local[4]= argv[3];
	local[5]= argv[7];
	local[6]= fqv[43];
	local[7]= fqv[21];
	ctx->vsp=local+8;
	w=(pointer)SEND(ctx,3,local+5); /*send*/
	local[5]= w;
	local[6]= makeint(60);
	ctx->vsp=local+7;
	w=(pointer)MINUS(ctx,2,local+5); /*-*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)LESSP(ctx,3,local+3); /*<*/
	if (w==NIL) goto AND2853;
	local[3]= makeint(60);
	local[4]= argv[4];
	local[5]= argv[7];
	local[6]= fqv[43];
	local[7]= fqv[22];
	ctx->vsp=local+8;
	w=(pointer)SEND(ctx,3,local+5); /*send*/
	local[5]= w;
	local[6]= makeint(60);
	ctx->vsp=local+7;
	w=(pointer)MINUS(ctx,2,local+5); /*-*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)LESSP(ctx,3,local+3); /*<*/
	if (w==NIL) goto AND2853;
	local[3]= loadglobal(fqv[54]);
	ctx->vsp=local+4;
	w=(*ftab[11])(ctx,1,local+3,&ftab[11],fqv[88]); /*event-left*/
	if (w==NIL) goto AND2853;
	goto OR2852;
AND2853:
	goto CON2851;
OR2852:
	local[3]= argv[0]->c.obj.iv[29];
	local[4]= argv[5];
	ctx->vsp=local+5;
	w=(pointer)MINUS(ctx,2,local+3); /*-*/
	argv[0]->c.obj.iv[29] = w;
	local[3]= argv[0]->c.obj.iv[30];
	local[4]= argv[6];
	ctx->vsp=local+5;
	w=(pointer)PLUS(ctx,2,local+3); /*+*/
	argv[0]->c.obj.iv[30] = w;
	local[3]= argv[0]->c.obj.iv[30];
	goto CON2849;
CON2851:
	local[3]= argv[3];
	local[4]= argv[7];
	local[5]= fqv[43];
	local[6]= fqv[21];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,3,local+4); /*send*/
	local[4]= w;
	local[5]= makeint(60);
	ctx->vsp=local+6;
	w=(pointer)MINUS(ctx,2,local+4); /*-*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)GREATERP(ctx,2,local+3); /*>*/
	if (w!=NIL) goto OR2855;
	local[3]= argv[4];
	local[4]= makeint(60);
	ctx->vsp=local+5;
	w=(pointer)LESSP(ctx,2,local+3); /*<*/
	if (w!=NIL) goto OR2855;
	goto CON2854;
OR2855:
	local[3]= argv[0]->c.obj.iv[31];
	local[4]= argv[0]->c.obj.iv[32];
	ctx->vsp=local+5;
	w=(pointer)VMINUS(ctx,2,local+3); /*v-*/
	local[3]= w;
	local[4]= argv[0];
	local[5]= fqv[68];
	local[6]= argv[0]->c.obj.iv[31];
	local[7]= makeflt(9.99999791e-03);
	local[8]= argv[4];
	local[9]= makeint(60);
	ctx->vsp=local+10;
	w=(pointer)LESSP(ctx,2,local+8); /*<*/
	if (w==NIL) goto IF2856;
	local[8]= argv[5];
	goto IF2857;
IF2856:
	local[8]= argv[6];
IF2857:
	local[9]= local[3];
	ctx->vsp=local+10;
	w=(pointer)VNORM(ctx,1,local+9); /*norm*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)ADD1(ctx,1,local+9); /*1+*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,3,local+7); /***/
	local[7]= w;
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(pointer)VNORMALIZE(ctx,1,local+8); /*normalize-vector*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)SCALEVEC(ctx,2,local+7); /*scale*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)VPLUS(ctx,2,local+6); /*v+*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,3,local+4); /*send*/
	local[3]= w;
	goto CON2849;
CON2854:
	local[3]= argv[4];
	local[4]= argv[7];
	local[5]= fqv[43];
	local[6]= fqv[22];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,3,local+4); /*send*/
	local[4]= w;
	local[5]= makeint(60);
	ctx->vsp=local+6;
	w=(pointer)MINUS(ctx,2,local+4); /*-*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)GREATERP(ctx,2,local+3); /*>*/
	if (w!=NIL) goto OR2859;
	local[3]= argv[3];
	local[4]= makeint(60);
	ctx->vsp=local+5;
	w=(pointer)LESSP(ctx,2,local+3); /*<*/
	if (w!=NIL) goto OR2859;
	goto CON2858;
OR2859:
	local[3]= argv[0]->c.obj.iv[31];
	local[4]= argv[0]->c.obj.iv[32];
	ctx->vsp=local+5;
	w=(pointer)VMINUS(ctx,2,local+3); /*v-*/
	local[3]= w;
	local[4]= argv[7];
	local[5]= fqv[70];
	local[6]= fqv[7];
	local[7]= makeflt(9.99999698e-04);
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(pointer)VNORM(ctx,1,local+8); /*norm*/
	{ double x,y;
		y=fltval(w); x=fltval(local[7]);
		local[7]=(makeflt(x * y));}
	local[8]= argv[3];
	local[9]= makeint(60);
	ctx->vsp=local+10;
	w=(pointer)LESSP(ctx,2,local+8); /*<*/
	if (w==NIL) goto IF2860;
	local[8]= makeint(0);
	local[9]= argv[6];
	local[10]= makeint(0);
	ctx->vsp=local+11;
	w=(pointer)MKFLTVEC(ctx,3,local+8); /*float-vector*/
	local[8]= w;
	goto IF2861;
IF2860:
	local[8]= makeint(-1);
	local[9]= argv[5];
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	local[9]= makeint(0);
	local[10]= makeint(0);
	ctx->vsp=local+11;
	w=(pointer)MKFLTVEC(ctx,3,local+8); /*float-vector*/
	local[8]= w;
IF2861:
	ctx->vsp=local+9;
	w=(pointer)SCALEVEC(ctx,2,local+7); /*scale*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SEND(ctx,4,local+4); /*send*/
	local[4]= w;
	local[5]= argv[0];
	local[6]= fqv[85];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,2,local+5); /*send*/
	local[5]= w;
	local[6]= local[4];
	local[7]= argv[0]->c.obj.iv[31];
	ctx->vsp=local+8;
	w=(pointer)VMINUS(ctx,2,local+6); /*v-*/
	local[6]= w;
	local[7]= argv[0];
	local[8]= fqv[68];
	local[9]= local[4];
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,3,local+7); /*send*/
	local[7]= argv[0];
	local[8]= fqv[85];
	local[9]= local[5];
	local[10]= local[6];
	ctx->vsp=local+11;
	w=(pointer)VPLUS(ctx,2,local+9); /*v+*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,3,local+7); /*send*/
	local[3]= w;
	goto CON2849;
CON2858:
	local[3]= NIL;
CON2849:
	ctx->vsp=local+4;
	unbindx(ctx,1);
	w = local[3];
	local[0]= w;
BLK2848:
	ctx->vsp=local; return(local[0]);}

/*:set-cursor-pos-event*/
static pointer M2862irtviewer_set_cursor_pos_event(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	w = argv[2];
	ctx->vsp=local+0;
	bindspecial(ctx,fqv[54],w);
	local[3]= loadglobal(fqv[54]);
	ctx->vsp=local+4;
	w=(*ftab[12])(ctx,1,local+3,&ftab[12],fqv[89]); /*event-pos*/
	argv[0]->c.obj.iv[28] = w;
	local[3]= argv[0]->c.obj.iv[28];
	ctx->vsp=local+4;
	unbindx(ctx,1);
	w = local[3];
	local[0]= w;
BLK2863:
	ctx->vsp=local; return(local[0]);}

/*:move-coords-event*/
static pointer M2864irtviewer_move_coords_event(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	w = argv[2];
	ctx->vsp=local+0;
	bindspecial(ctx,fqv[54],w);
	if (argv[0]->c.obj.iv[28]!=NIL) goto IF2866;
	local[3]= loadglobal(fqv[54]);
	ctx->vsp=local+4;
	w=(*ftab[12])(ctx,1,local+3,&ftab[12],fqv[89]); /*event-pos*/
	argv[0]->c.obj.iv[28] = w;
	local[3]= argv[0]->c.obj.iv[28];
	goto IF2867;
IF2866:
	local[3]= NIL;
IF2867:
	local[3]= loadglobal(fqv[54]);
	ctx->vsp=local+4;
	w=(*ftab[12])(ctx,1,local+3,&ftab[12],fqv[89]); /*event-pos*/
	local[3]= w;
	local[4]= local[3];
	local[5]= makeint(0);
	ctx->vsp=local+6;
	w=(pointer)ELT(ctx,2,local+4); /*elt*/
	local[4]= w;
	local[5]= local[3];
	local[6]= makeint(1);
	ctx->vsp=local+7;
	w=(pointer)ELT(ctx,2,local+5); /*elt*/
	local[5]= w;
	local[6]= local[4];
	local[7]= argv[0]->c.obj.iv[28];
	local[8]= makeint(0);
	ctx->vsp=local+9;
	w=(pointer)ELT(ctx,2,local+7); /*elt*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)MINUS(ctx,2,local+6); /*-*/
	local[6]= w;
	local[7]= local[5];
	local[8]= argv[0]->c.obj.iv[28];
	local[9]= makeint(1);
	ctx->vsp=local+10;
	w=(pointer)ELT(ctx,2,local+8); /*elt*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)MINUS(ctx,2,local+7); /*-*/
	local[7]= w;
	local[8]= argv[0];
	local[9]= fqv[90];
	local[10]= loadglobal(fqv[54]);
	local[11]= local[4];
	local[12]= local[5];
	local[13]= local[6];
	local[14]= local[7];
	local[15]= argv[0]->c.obj.iv[25];
	ctx->vsp=local+16;
	w=(pointer)SEND(ctx,8,local+8); /*send*/
	local[8]= argv[0];
	local[9]= fqv[52];
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,2,local+8); /*send*/
	local[8]= argv[0];
	local[9]= fqv[14];
	ctx->vsp=local+10;
	w=(pointer)SEND(ctx,2,local+8); /*send*/
	argv[0]->c.obj.iv[28] = local[3];
	w = argv[0]->c.obj.iv[28];
	local[3]= w;
	ctx->vsp=local+4;
	unbindx(ctx,1);
	w = local[3];
	local[0]= w;
BLK2865:
	ctx->vsp=local; return(local[0]);}

/*:draw-event*/
static pointer M2868irtviewer_draw_event(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	w = argv[2];
	ctx->vsp=local+0;
	bindspecial(ctx,fqv[54],w);
	local[3]= argv[0];
	local[4]= fqv[14];
	ctx->vsp=local+5;
	w=(pointer)SEND(ctx,2,local+3); /*send*/
	local[3]= w;
	ctx->vsp=local+4;
	unbindx(ctx,1);
	w = local[3];
	local[0]= w;
BLK2869:
	ctx->vsp=local; return(local[0]);}

/*:draw-objects*/
static pointer M2870irtviewer_draw_objects(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2872:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	local[1]= argv[0]->c.obj.iv[25];
	local[2]= fqv[43];
	local[3]= fqv[56];
	ctx->vsp=local+4;
	w=(pointer)SEND(ctx,3,local+1); /*send*/
	local[1]= (pointer)get_sym_func(fqv[91]);
	local[2]= argv[0]->c.obj.iv[25];
	local[3]= argv[0]->c.obj.iv[27];
	local[4]= fqv[92];
	local[5]= argv[0]->c.obj.iv[34];
	local[6]= fqv[93];
	local[7]= argv[0]->c.obj.iv[35];
	local[8]= local[0];
	ctx->vsp=local+9;
	w=(pointer)APPLY(ctx,8,local+1); /*apply*/
	local[0]= w;
BLK2871:
	ctx->vsp=local; return(local[0]);}

/*:objects*/
static pointer M2873irtviewer_objects(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2875:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	if (local[0]==NIL) goto IF2876;
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	if ((w)->c.cons.car!=NIL) goto CON2879;
	argv[0]->c.obj.iv[26] = NIL;
	local[1]= argv[0]->c.obj.iv[26];
	goto CON2878;
CON2879:
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w = (w)->c.cons.car;
	if (!iscons(w)) goto CON2880;
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	argv[0]->c.obj.iv[26] = (w)->c.cons.car;
	local[1]= argv[0]->c.obj.iv[26];
	goto CON2878;
CON2880:
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w = (w)->c.cons.car;
	if (!!iscons(w)) goto CON2881;
	local[1]= local[0];
	local[2]= argv[0]->c.obj.iv[26];
	ctx->vsp=local+3;
	w=(pointer)APPEND(ctx,2,local+1); /*append*/
	argv[0]->c.obj.iv[26] = w;
	local[1]= argv[0]->c.obj.iv[26];
	goto CON2878;
CON2881:
	local[1]= NIL;
CON2878:
	goto IF2877;
IF2876:
	local[1]= NIL;
IF2877:
	local[1]= argv[0]->c.obj.iv[26];
	local[2]= fqv[73];
	ctx->vsp=local+3;
	w=(*ftab[5])(ctx,2,local+1,&ftab[5],fqv[74]); /*send-all*/
	local[1]= argv[0]->c.obj.iv[26];
	ctx->vsp=local+2;
	w=(pointer)F2758draw_things(ctx,1,local+1); /*draw-things*/
	argv[0]->c.obj.iv[27] = w;
	w = argv[0]->c.obj.iv[26];
	local[0]= w;
BLK2874:
	ctx->vsp=local; return(local[0]);}

/*:select-drawmode*/
static pointer M2882irtviewer_select_drawmode(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	local[0]= argv[2];
	if (argv[0]->c.obj.iv[33]==local[0]) goto IF2884;
	local[0]= argv[0];
	local[1]= fqv[69];
	local[2]= fqv[43];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	local[0]= *(ovafptr(w,fqv[94]));
	local[1]= NIL;
	local[2]= argv[0]->c.obj.iv[27];
WHL2887:
	if (local[2]==NIL) goto WHX2888;
	w=local[2];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3]= (w)->c.cons.car;
	w=local[2];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[2] = (w)->c.cons.cdr;
	w = local[3];
	local[1] = w;
	local[3]= local[1];
	local[4]= fqv[95];
	ctx->vsp=local+5;
	w=(pointer)GETPROP(ctx,2,local+3); /*get*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(*ftab[13])(ctx,1,local+3,&ftab[13],fqv[96]); /*gl::delete-displaylist-id*/
	local[3]= local[1];
	local[4]= NIL;
	local[5]= fqv[95];
	ctx->vsp=local+6;
	w=(pointer)PUTPROP(ctx,3,local+3); /*putprop*/
	local[3]= argv[2];
	local[4]= local[3];
	if (fqv[97]!=local[4]) goto IF2892;
	local[4]= local[1];
	local[5]= local[0];
	w = T;
	ctx->vsp=local+6;
	local[5]= cons(ctx,local[5],w);
	ctx->vsp=local+6;
	w=(pointer)LIST(ctx,1,local+5); /*list*/
	local[5]= w;
	local[6]= fqv[98];
	ctx->vsp=local+7;
	w=(pointer)PUTPROP(ctx,3,local+4); /*putprop*/
	local[4]= w;
	goto IF2893;
IF2892:
	if (T==NIL) goto IF2894;
	local[4]= local[1];
	local[5]= NIL;
	local[6]= fqv[98];
	ctx->vsp=local+7;
	w=(pointer)PUTPROP(ctx,3,local+4); /*putprop*/
	local[4]= w;
	goto IF2895;
IF2894:
	local[4]= NIL;
IF2895:
IF2893:
	w = local[4];
	goto WHL2887;
WHX2888:
	local[3]= NIL;
BLK2889:
	w = NIL;
	local[0]= w;
	goto IF2885;
IF2884:
	local[0]= NIL;
IF2885:
	argv[0]->c.obj.iv[33] = argv[2];
	w = argv[0]->c.obj.iv[33];
	local[0]= w;
BLK2883:
	ctx->vsp=local; return(local[0]);}

/*:flush*/
static pointer M2896irtviewer_flush(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	if (argv[0]->c.obj.iv[25]==NIL) goto IF2898;
	local[0]= argv[0]->c.obj.iv[25];
	local[1]= fqv[43];
	local[2]= fqv[99];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	local[0]= w;
	goto IF2899;
IF2898:
	local[0]= NIL;
IF2899:
	w = local[0];
	local[0]= w;
BLK2897:
	ctx->vsp=local; return(local[0]);}

/*:change-background*/
static pointer M2900irtviewer_change_background(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	local[0]= argv[0];
	local[1]= fqv[69];
	local[2]= fqv[43];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	local[0]= w;
	local[1]= local[0];
	local[2]= fqv[56];
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,2,local+1); /*send*/
	local[1]= argv[2];
	local[2]= local[1];
	*(ovafptr(local[0],fqv[100])) = local[2];
	local[1]= argv[2];
	ctx->vsp=local+2;
	w=(*ftab[14])(ctx,1,local+1,&ftab[14],fqv[101]); /*gl:glclearcolorfv*/
	local[0]= w;
BLK2901:
	ctx->vsp=local; return(local[0]);}

/*draw-things*/
static pointer F2758draw_things(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	w = argv[0];
	if (!!iscons(w)) goto CON2904;
	if (argv[0]!=NIL) goto CON2906;
	local[0]= NIL;
	goto CON2905;
CON2906:
	local[0]= argv[0];
	local[1]= fqv[102];
	ctx->vsp=local+2;
	w=(*ftab[15])(ctx,2,local+0,&ftab[15],fqv[103]); /*find-method*/
	if (w==NIL) goto CON2907;
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(pointer)LIST(ctx,1,local+0); /*list*/
	local[0]= w;
	goto CON2905;
CON2907:
	local[0]= argv[0];
	local[1]= fqv[104];
	ctx->vsp=local+2;
	w=(*ftab[15])(ctx,2,local+0,&ftab[15],fqv[103]); /*find-method*/
	if (w==NIL) goto CON2908;
	local[0]= argv[0];
	local[1]= fqv[104];
	ctx->vsp=local+2;
	w=(pointer)SEND(ctx,2,local+0); /*send*/
	local[0]= w;
	goto CON2905;
CON2908:
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(pointer)LIST(ctx,1,local+0); /*list*/
	local[0]= w;
	goto CON2905;
CON2909:
	local[0]= NIL;
CON2905:
	goto CON2903;
CON2904:
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[0]= (w)->c.cons.car;
	ctx->vsp=local+1;
	w=(pointer)F2758draw_things(ctx,1,local+0); /*draw-things*/
	local[0]= w;
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[1]= (w)->c.cons.cdr;
	ctx->vsp=local+2;
	w=(pointer)F2758draw_things(ctx,1,local+1); /*draw-things*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(pointer)APPEND(ctx,2,local+0); /*append*/
	local[0]= w;
	goto CON2903;
CON2910:
	local[0]= NIL;
CON2903:
	w = local[0];
	local[0]= w;
BLK2902:
	ctx->vsp=local; return(local[0]);}

/*:look*/
static pointer M2911viewing_look(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<3) maerror();
	if (n>=4) { local[0]=(argv[3]); goto ENT2915;}
	local[0]= makeint(0);
	local[1]= makeint(0);
	local[2]= makeint(0);
	ctx->vsp=local+3;
	w=(pointer)MKFLTVEC(ctx,3,local+0); /*float-vector*/
	local[0]= w;
ENT2915:
	if (n>=5) { local[1]=(argv[4]); goto ENT2914;}
	local[1]= makeint(0);
	local[2]= makeint(0);
	local[3]= makeint(1);
	ctx->vsp=local+4;
	w=(pointer)MKFLTVEC(ctx,3,local+1); /*float-vector*/
	local[1]= w;
ENT2914:
ENT2913:
	if (n>5) maerror();
	local[2]= local[0];
	local[3]= argv[2];
	ctx->vsp=local+4;
	w=(pointer)VMINUS(ctx,2,local+2); /*v-*/
	local[2]= w;
	ctx->vsp=local+3;
	w=(pointer)VNORMALIZE(ctx,1,local+2); /*normalize-vector*/
	local[2]= w;
	local[3]= local[2];
	local[4]= local[1];
	ctx->vsp=local+5;
	w=(pointer)VCROSSPRODUCT(ctx,2,local+3); /*v**/
	local[3]= w;
	local[4]= NIL;
	local[5]= local[3];
	ctx->vsp=local+6;
	w=(pointer)VNORM(ctx,1,local+5); /*norm*/
	local[5]= w;
	local[6]= loadglobal(fqv[105]);
	ctx->vsp=local+7;
	w=(pointer)LESSP(ctx,2,local+5); /*<*/
	if (w==NIL) goto IF2916;
	local[5]= local[2];
	local[6]= makeint(-1);
	local[7]= makeint(0);
	local[8]= makeint(0);
	ctx->vsp=local+9;
	w=(pointer)MKFLTVEC(ctx,3,local+6); /*float-vector*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)VCROSSPRODUCT(ctx,2,local+5); /*v**/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)VNORMALIZE(ctx,1,local+5); /*normalize-vector*/
	local[4] = w;
	local[5]= local[4];
	goto IF2917;
IF2916:
	local[5]= local[3];
	ctx->vsp=local+6;
	w=(pointer)VNORMALIZE(ctx,1,local+5); /*normalize-vector*/
	local[4] = w;
	local[5]= local[4];
IF2917:
	local[5]= local[4];
	local[6]= local[2];
	ctx->vsp=local+7;
	w=(pointer)VCROSSPRODUCT(ctx,2,local+5); /*v**/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)VNORMALIZE(ctx,1,local+5); /*normalize-vector*/
	local[1] = w;
	local[5]= makeflt(-1.00000000e+00);
	local[6]= local[2];
	ctx->vsp=local+7;
	w=(pointer)SCALEVEC(ctx,2,local+5); /*scale*/
	local[2] = w;
	local[5]= loadglobal(fqv[106]);
	local[6]= local[4];
	local[7]= local[1];
	local[8]= local[2];
	ctx->vsp=local+9;
	w=(pointer)CONCATENATE(ctx,4,local+5); /*concatenate*/
	local[5]= w;
	local[6]= w;
	w = argv[0]->c.obj.iv[1];
	w->c.obj.iv[1] = local[6];
	local[5]= argv[0]->c.obj.iv[1];
	local[6]= argv[0]->c.obj.iv[1];
	ctx->vsp=local+7;
	w=(pointer)TRANSPOSE(ctx,2,local+5); /*transpose*/
	local[5]= argv[0];
	local[6]= fqv[107];
	local[7]= argv[2];
	local[8]= fqv[108];
	ctx->vsp=local+9;
	w=(pointer)SEND(ctx,4,local+5); /*send*/
	local[5]= argv[0];
	local[6]= fqv[73];
	ctx->vsp=local+7;
	w=(pointer)SEND(ctx,2,local+5); /*send*/
	local[0]= w;
BLK2912:
	ctx->vsp=local; return(local[0]);}

/*objects*/
static pointer F2759objects(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ENT2921;}
	local[0]= T;
ENT2921:
	if (n>=2) { local[1]=(argv[1]); goto ENT2920;}
	local[1]= NIL;
ENT2920:
ENT2919:
	if (n>2) maerror();
	if (local[0]==NIL) goto IF2922;
	local[2]= fqv[109];
	ctx->vsp=local+3;
	w=(pointer)BOUNDP(ctx,1,local+2); /*boundp*/
	if (w!=NIL) goto IF2922;
	if (local[1]!=NIL) goto IF2922;
	local[2]= fqv[110];
	ctx->vsp=local+3;
	w=(*ftab[3])(ctx,1,local+2,&ftab[3],fqv[64]); /*warn*/
	ctx->vsp=local+2;
	w=(pointer)F2760make_irtviewer(ctx,0,local+2); /*make-irtviewer*/
	local[2]= w;
	goto IF2923;
IF2922:
	local[2]= NIL;
IF2923:
	if (local[1]!=NIL) goto IF2924;
	local[1] = loadglobal(fqv[109]);
	local[2]= local[1];
	goto IF2925;
IF2924:
	local[2]= NIL;
IF2925:
	local[2]= NIL;
	local[3]= local[0];
	if (T!=local[3]) goto IF2926;
	local[3]= local[1];
	local[4]= fqv[111];
	ctx->vsp=local+5;
	w=(pointer)SEND(ctx,2,local+3); /*send*/
	local[2] = w;
	local[3]= local[2];
	goto IF2927;
IF2926:
	local[3]= local[1];
	local[4]= fqv[111];
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)SEND(ctx,3,local+3); /*send*/
	local[2] = w;
	local[3]= local[2];
IF2927:
	local[3]= local[1];
	local[4]= fqv[112];
	ctx->vsp=local+5;
	w=(pointer)SEND(ctx,2,local+3); /*send*/
	w = local[2];
	local[0]= w;
BLK2918:
	ctx->vsp=local; return(local[0]);}

/*make-irtviewer*/
static pointer F2760make_irtviewer(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
RST2929:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-0);
	if (loadglobal(fqv[113])==NIL) goto OR2932;
	local[1]= loadglobal(fqv[113]);
	local[2]= makeint(0);
	ctx->vsp=local+3;
	w=(pointer)NUMEQUAL(ctx,2,local+1); /*=*/
	if (w!=NIL) goto OR2932;
	goto CON2931;
OR2932:
	local[1]= makeint(1);
	local[2]= fqv[114];
	ctx->vsp=local+3;
	w=(*ftab[8])(ctx,2,local+1,&ftab[8],fqv[84]); /*warning-message*/
	local[1]= loadglobal(fqv[115]);
	ctx->vsp=local+2;
	w=(pointer)INSTANTIATE(ctx,1,local+1); /*instantiate*/
	local[1]= w;
	storeglobal(fqv[109],w);
	local[1]= loadglobal(fqv[116]);
	ctx->vsp=local+2;
	w=(pointer)INSTANTIATE(ctx,1,local+1); /*instantiate*/
	local[1]= w;
	storeglobal(fqv[32],w);
	local[1]= loadglobal(fqv[32]);
	local[2]= loadglobal(fqv[109]);
	local[3]= fqv[13];
	ctx->vsp=local+4;
	w=(pointer)PUTPROP(ctx,3,local+1); /*putprop*/
	local[1]= w;
	goto CON2930;
CON2931:
	local[1]= (pointer)get_sym_func(fqv[12]);
	local[2]= loadglobal(fqv[117]);
	ctx->vsp=local+3;
	w=(pointer)INSTANTIATE(ctx,1,local+2); /*instantiate*/
	local[2]= w;
	local[3]= fqv[20];
	local[4]= local[0];
	ctx->vsp=local+5;
	w=(pointer)APPLY(ctx,4,local+1); /*apply*/
	local[1]= w;
	storeglobal(fqv[109],w);
	goto CON2930;
CON2933:
	local[1]= NIL;
CON2930:
	w = loadglobal(fqv[109]);
	local[0]= w;
BLK2928:
	ctx->vsp=local; return(local[0]);}

/*:nomethod*/
static pointer M2934viewer_dummy_nomethod(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2936:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	w = T;
	local[0]= w;
BLK2935:
	ctx->vsp=local; return(local[0]);}

/*:objects*/
static pointer M2937irtviewer_dummy_objects(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2939:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	if (local[0]==NIL) goto IF2940;
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	if ((w)->c.cons.car!=NIL) goto CON2943;
	argv[0]->c.obj.iv[1] = NIL;
	local[1]= argv[0]->c.obj.iv[1];
	goto CON2942;
CON2943:
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w = (w)->c.cons.car;
	if (!iscons(w)) goto CON2944;
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	argv[0]->c.obj.iv[1] = (w)->c.cons.car;
	local[1]= argv[0]->c.obj.iv[1];
	goto CON2942;
CON2944:
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w = (w)->c.cons.car;
	if (!!iscons(w)) goto CON2945;
	local[1]= local[0];
	local[2]= argv[0]->c.obj.iv[1];
	ctx->vsp=local+3;
	w=(pointer)APPEND(ctx,2,local+1); /*append*/
	argv[0]->c.obj.iv[1] = w;
	local[1]= argv[0]->c.obj.iv[1];
	goto CON2942;
CON2945:
	local[1]= NIL;
CON2942:
	goto IF2941;
IF2940:
	local[1]= NIL;
IF2941:
	local[1]= argv[0]->c.obj.iv[1];
	local[2]= fqv[73];
	ctx->vsp=local+3;
	w=(*ftab[5])(ctx,2,local+1,&ftab[5],fqv[74]); /*send-all*/
	local[1]= argv[0]->c.obj.iv[1];
	ctx->vsp=local+2;
	w=(pointer)F2758draw_things(ctx,1,local+1); /*x::draw-things*/
	argv[0]->c.obj.iv[2] = w;
	w = argv[0]->c.obj.iv[1];
	local[0]= w;
BLK2938:
	ctx->vsp=local; return(local[0]);}

/*:nomethod*/
static pointer M2946irtviewer_dummy_nomethod(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
RST2948:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-2);
	w = T;
	local[0]= w;
BLK2947:
	ctx->vsp=local; return(local[0]);}

/*make-irtviewer-dummy*/
static pointer F2761make_irtviewer_dummy(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
RST2950:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-0);
	local[1]= makeint(1);
	local[2]= fqv[118];
	ctx->vsp=local+3;
	w=(*ftab[8])(ctx,2,local+1,&ftab[8],fqv[84]); /*warning-message*/
	local[1]= loadglobal(fqv[119]);
	ctx->vsp=local+2;
	w=(pointer)INSTANTIATE(ctx,1,local+1); /*instantiate*/
	local[1]= w;
	storeglobal(fqv[109],w);
	w = local[1];
	local[0]= w;
BLK2949:
	ctx->vsp=local; return(local[0]);}

/* initializer*/
pointer ___irtviewer(ctx,n,argv,env)
register context *ctx; int n; pointer *argv; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv;
  register int i;
  numunion nu;
  module=argv[0];
  quotevec=build_quote_vector(ctx,QUOTE_STRINGS_SIZE, quote_strings);
  module->c.code.quotevec=quotevec;
  codevec=module->c.code.codevec;
  fqv=qv=quotevec->c.vec.v;
  init_ftab();
	local[0]= fqv[120];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	if (w==NIL) goto IF2951;
	local[0]= fqv[121];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	local[0]= w;
	storeglobal(fqv[122],w);
	goto IF2952;
IF2951:
	local[0]= fqv[123];
	ctx->vsp=local+1;
	w=(pointer)SIGERROR(ctx,1,local+0); /*error*/
	local[0]= w;
IF2952:
	ctx->vsp=local+0;
	compfun(ctx,fqv[124],module,F2757make_lr_ud_coords,fqv[125]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2763geometry_viewer_draw_circle,fqv[126],fqv[127],fqv[128]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2780geometry_viewer_draw_objects,fqv[14],fqv[127],fqv[129]);
	local[0]= fqv[41];
	local[1]= fqv[130];
	ctx->vsp=local+2;
	w=(pointer)SEND(ctx,2,local+0); /*send*/
	local[0]= w;
	local[1]= makeint(1);
	ctx->vsp=local+2;
	w=(pointer)EQ(ctx,2,local+0); /*eql*/
	if (w==NIL) goto IF2953;
	local[0]= fqv[41];
	local[1]= fqv[130];
	local[2]= makeint(2);
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	local[0]= fqv[41];
	ctx->vsp=local+1;
	w=(pointer)BOUNDP(ctx,1,local+0); /*boundp*/
	if (w!=NIL) goto IF2955;
	local[0]= fqv[41];
	local[1]= fqv[131];
	local[2]= NIL;
	local[3]= NIL;
	ctx->vsp=local+4;
	w=(pointer)SEND(ctx,4,local+0); /*send*/
	local[0]= w;
	goto IF2956;
IF2955:
	local[0]= NIL;
IF2956:
	local[0]= fqv[41];
	goto IF2954;
IF2953:
	local[0]= NIL;
IF2954:
	local[0]= fqv[117];
	local[1]= fqv[131];
	local[2]= fqv[117];
	local[3]= fqv[132];
	local[4]= loadglobal(fqv[133]);
	local[5]= fqv[134];
	local[6]= fqv[135];
	local[7]= fqv[136];
	local[8]= NIL;
	local[9]= fqv[137];
	local[10]= NIL;
	local[11]= fqv[138];
	local[12]= makeint(-1);
	local[13]= fqv[139];
	local[14]= NIL;
	ctx->vsp=local+15;
	w=(*ftab[16])(ctx,13,local+2,&ftab[16],fqv[140]); /*make-class*/
	local[2]= w;
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2783irtviewer_create,fqv[20],fqv[117],fqv[141]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2798irtviewer_viewer,fqv[69],fqv[117],fqv[142]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2801irtviewer_redraw,fqv[61],fqv[117],fqv[143]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2803irtviewer_expose,fqv[144],fqv[117],fqv[145]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2805irtviewer_resize,fqv[55],fqv[117],fqv[146]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2807irtviewer_configurenotify,fqv[147],fqv[117],fqv[148]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2814irtviewer_viewtarget,fqv[85],fqv[117],fqv[149]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2820irtviewer_viewpoint,fqv[68],fqv[117],fqv[150]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2826irtviewer_look1,fqv[52],fqv[117],fqv[151]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2834irtviewer_look_all,fqv[112],fqv[117],fqv[152]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2847irtviewer_move_viewing_around_viewtarget,fqv[90],fqv[117],fqv[153]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2862irtviewer_set_cursor_pos_event,fqv[48],fqv[117],fqv[154]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2864irtviewer_move_coords_event,fqv[50],fqv[117],fqv[155]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2868irtviewer_draw_event,fqv[46],fqv[117],fqv[156]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2870irtviewer_draw_objects,fqv[14],fqv[117],fqv[157]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2873irtviewer_objects,fqv[111],fqv[117],fqv[158]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2882irtviewer_select_drawmode,fqv[159],fqv[117],fqv[160]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2896irtviewer_flush,fqv[11],fqv[117],fqv[161]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2900irtviewer_change_background,fqv[162],fqv[117],fqv[163]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[164],module,F2758draw_things,fqv[165]);
	local[0]= fqv[166];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	if (w==NIL) goto IF2957;
	local[0]= fqv[167];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	local[0]= w;
	storeglobal(fqv[122],w);
	goto IF2958;
IF2957:
	local[0]= fqv[168];
	ctx->vsp=local+1;
	w=(pointer)SIGERROR(ctx,1,local+0); /*error*/
	local[0]= w;
IF2958:
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2911viewing_look,fqv[71],fqv[169],fqv[170]);
	local[0]= fqv[171];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	if (w==NIL) goto IF2959;
	local[0]= fqv[172];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	local[0]= w;
	storeglobal(fqv[122],w);
	goto IF2960;
IF2959:
	local[0]= fqv[173];
	ctx->vsp=local+1;
	w=(pointer)SIGERROR(ctx,1,local+0); /*error*/
	local[0]= w;
IF2960:
	ctx->vsp=local+0;
	compfun(ctx,fqv[174],module,F2759objects,fqv[175]);
	local[0]= fqv[176];
	ctx->vsp=local+1;
	w=(pointer)PROCLAIM(ctx,1,local+0); /*proclaim*/
	ctx->vsp=local+0;
	compfun(ctx,fqv[177],module,F2760make_irtviewer,fqv[178]);
	local[0]= fqv[116];
	local[1]= fqv[131];
	local[2]= fqv[116];
	local[3]= fqv[132];
	local[4]= loadglobal(fqv[179]);
	local[5]= fqv[134];
	local[6]= fqv[180];
	local[7]= fqv[136];
	local[8]= NIL;
	local[9]= fqv[137];
	local[10]= NIL;
	local[11]= fqv[138];
	local[12]= makeint(-1);
	local[13]= fqv[139];
	local[14]= NIL;
	ctx->vsp=local+15;
	w=(*ftab[16])(ctx,13,local+2,&ftab[16],fqv[140]); /*make-class*/
	local[2]= w;
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2934viewer_dummy_nomethod,fqv[181],fqv[116],fqv[182]);
	local[0]= fqv[115];
	local[1]= fqv[131];
	local[2]= fqv[115];
	local[3]= fqv[132];
	local[4]= loadglobal(fqv[179]);
	local[5]= fqv[134];
	local[6]= fqv[183];
	local[7]= fqv[136];
	local[8]= NIL;
	local[9]= fqv[137];
	local[10]= NIL;
	local[11]= fqv[138];
	local[12]= makeint(-1);
	local[13]= fqv[139];
	local[14]= NIL;
	ctx->vsp=local+15;
	w=(*ftab[16])(ctx,13,local+2,&ftab[16],fqv[140]); /*make-class*/
	local[2]= w;
	ctx->vsp=local+3;
	w=(pointer)SEND(ctx,3,local+0); /*send*/
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2937irtviewer_dummy_objects,fqv[111],fqv[115],fqv[184]);
	ctx->vsp=local+0;
	addcmethod(ctx,module,M2946irtviewer_dummy_nomethod,fqv[181],fqv[115],fqv[185]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[186],module,F2761make_irtviewer_dummy,fqv[187]);
	local[0]= fqv[188];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	if (w==NIL) goto IF2961;
	local[0]= fqv[189];
	ctx->vsp=local+1;
	w=(pointer)FINDPACKAGE(ctx,1,local+0); /*find-package*/
	local[0]= w;
	storeglobal(fqv[122],w);
	goto IF2962;
IF2961:
	local[0]= fqv[190];
	ctx->vsp=local+1;
	w=(pointer)SIGERROR(ctx,1,local+0); /*error*/
	local[0]= w;
IF2962:
	local[0]= fqv[191];
	local[1]= fqv[192];
	ctx->vsp=local+2;
	w=(*ftab[17])(ctx,2,local+0,&ftab[17],fqv[193]); /*provide*/
	local[0]= NIL;
	ctx->vsp=local; return(local[0]);}
static void init_ftab()
{  register int i;
  for (i=0; i<18; i++) ftab[i]=fcallx;
}
